OpenTTD Source: SmallMapWindow Class Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes | Friends
SmallMapWindow Class Reference

Class managing the smallmap window. More...

Inheritance diagram for SmallMapWindow:

## Public Member Functions
| SmallMapWindow (WindowDesc &desc, int window_number)
void | SmallMapCenterOnCurrentPos ()
| Center the small map on the current center of the viewport.
Point | GetStationMiddle (const Station *st) const
| Get the center of the given station as point on the screen in the smallmap window.
void | Close (int data) override
| Hide the window and all its child windows, and mark them for a later deletion.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | OnPaint () override
| The window must be repainted.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
bool | OnRightClick (Point, WidgetID widget) override
| A click with the right mouse button has been made on the window.
void | OnMouseWheel (int wheel, WidgetID widget) override
| The mouse wheel has been turned.
void | OnScroll (Point delta) override
| Handle the request for (viewport) scrolling.
void | OnMouseOver (Point pt, WidgetID widget) override
| The mouse is currently moving over the window or has just moved outside of the window.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize)
| Update size and resize step of a widget in the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnDropdownSelect (WidgetID widget, int index, int click_result)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Protected Types
enum | ZoomLevelChange : uint8_t { ZLC_INITIALIZE , ZLC_ZOOM_OUT , ZLC_ZOOM_IN }
| Available kinds of zoomlevel changes. More...

## Protected Member Functions
uint | GetMinLegendWidth () const
| Compute minimal required width of the legends.
uint | GetNumberColumnsLegend (uint width) const
| Return number of columns that can be displayed in width pixels.
uint | GetLegendHeight (uint num_columns) const
| Compute height given a number of columns.
CompanyMask | GetOverlayCompanyMask () const
| Get a bitmask for company links to be displayed.
void | RebuildColourIndexIfNecessary ()
| Rebuilds the colour indices used for fast access to the smallmap contour colours based on the heightlevel.
uint | GetNumberRowsLegend (uint columns) const
| Get the number of rows in the legend from the number of columns.
void | SelectLegendItem (int click_pos, LegendAndColour *legend, int end_legend_item, int begin_legend_item=0)
| Select and toggle a legend item.
void | SwitchMapType (SmallMapType map_type)
| Select a new map type.
void | SetNewScroll (int sx, int sy, int sub)
| Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.
void | DrawMapIndicators () const
| Adds map indicators to the smallmap.
void | DrawSmallMapColumn (void *dst, uint xc, uint yc, int pitch, int reps, int start_pos, int end_pos, Blitter *blitter) const
| Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.
void | DrawVehicles (const DrawPixelInfo *dpi, Blitter *blitter) const
| Adds vehicles to the smallmap.
void | DrawTowns (const DrawPixelInfo *dpi, const int vertical_padding) const
| Adds town names to the smallmap.
void | DrawIndustryNames (const DrawPixelInfo *dpi, const int vertical_padding) const
| Adds industry names to the smallmap.
void | DrawSmallMap (DrawPixelInfo *dpi) const
| Draws the small map.
Point | RemapTile (int tile_x, int tile_y) const
| Remap tile to location on this smallmap.
Point | PixelToTile (int px, int py, int *sub, bool add_sub=true) const
| Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.
Point | ComputeScroll (int tx, int ty, int x, int y, int *sub) const
| Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).
void | SetZoomLevel (ZoomLevelChange change, const Point *zoom_pt)
| Initialize or change the zoom level.
void | SetOverlayCargoMask ()
| Set the link graph overlay cargo mask from the legend.
void | SetupWidgetData ()
| Function to set up widgets depending on the information being shown on the smallmap.
uint32_t | GetTileColours (const TileArea &ta) const
| Decide which colours to show to the user for a group of tiles.
int | GetPositionOnLegend (Point pt)
| Determines the mouse position on the legend.
void | UpdateLinks ()
| Update all the links on the map.
void | Blink ()
| Blink the industries (if hover over an industry).
void | ForceRefresh ()
| Force a full refresh of the map.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.

## Static Protected Member Functions
static void | BreakIndustryChainLink ()
| Notify the industry chain window to stop sending newly selected industries.
static Point | SmallmapRemapCoords (int x, int y)
static void | DrawVertMapIndicator (int x, int y, int y2)
| Draws vertical part of map indicator.
static void | DrawHorizMapIndicator (int x, int x2, int y)
| Draws horizontal part of map indicator.

## Protected Attributes
uint | min_number_of_columns = 0
| Minimal number of columns in legends.
uint | min_number_of_fixed_rows = 0
| Minimal number of rows in the legends for the fixed layouts only (all except SMT_INDUSTRY).
uint | column_width = 0
| Width of a column in the WID_SM_LEGEND widget.
uint | legend_width = 0
| Width of legend 'blob'.
int32_t | scroll_x = 0
| Horizontal world coordinate of the base tile left of the top-left corner of the smallmap display.
int32_t | scroll_y = 0
| Vertical world coordinate of the base tile left of the top-left corner of the smallmap display.
int32_t | subscroll = 0
| Number of pixels (0..3) between the right end of the base tile and the pixel at the top-left corner of the smallmap display.
int | zoom = 0
| Zoom level. Bigger number means more zoom-out (further away).
std::unique_ptr< LinkGraphOverlay > | overlay {}
const IntervalTimer< TimerWindow > | blink_interval
| Blink the industries (if selected) on a regular interval.
const IntervalTimer< TimerWindow > | refresh_interval
| Update the whole map on a regular interval.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Static Protected Attributes
static SmallMapType | map_type = SMT_CONTOUR
| Currently displayed legends.
static bool | show_towns = true
| Display town names in the smallmap.
static bool | show_ind_names = false
| Display industry names in the smallmap.
static int | map_height_limit = -1
| Currently used/cached map height limit.
static const uint | INDUSTRY_MIN_NUMBER_OF_COLUMNS = 2
| Minimal number of columns in the WID_SM_LEGEND widget for the SMT_INDUSTRY legend.

## Friends
class | NWidgetSmallmapDisplay

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}

## Detailed Description

Class managing the smallmap window.

Definition at line 627 of file smallmap_gui.cpp.

## Member Enumeration Documentation

## ◆ ZoomLevelChange

enum SmallMapWindow::ZoomLevelChange : uint8_t
| protected

Available kinds of zoomlevel changes.

Enumerator
ZLC_INITIALIZE | Initialize zoom level.
ZLC_ZOOM_OUT | Zoom out.
ZLC_ZOOM_IN | Zoom in.

Definition at line 630 of file smallmap_gui.cpp.

## Constructor & Destructor Documentation

## ◆ SmallMapWindow()

SmallMapWindow::SmallMapWindow | ( | WindowDesc & | desc,
|  | int | window_number
| ) |  |
| inline

Definition at line 1453 of file smallmap_gui.cpp.

## Member Function Documentation

## ◆ Blink()

void SmallMapWindow::Blink | ( |  | ) |
| inlineprotected

Blink the industries (if hover over an industry).

Definition at line 1431 of file smallmap_gui.cpp.

References _smallmap_industry_highlight, and _smallmap_industry_highlight_state.

## ◆ BreakIndustryChainLink()

static void SmallMapWindow::BreakIndustryChainLink | ( |  | ) |
| inlinestaticprotected

Notify the industry chain window to stop sending newly selected industries.

Definition at line 656 of file smallmap_gui.cpp.

References InvalidateWindowClassesData(), NUM_INDUSTRYTYPES, and WC_INDUSTRY_CARGOES.

## ◆ Close()

void SmallMapWindow::Close | ( | int | data | ) |
| inlineoverridevirtual

Hide the window and all its child windows, and mark them for a later deletion.

Reimplemented from Window.

Definition at line 1509 of file smallmap_gui.cpp.

References Window::Close().

## ◆ ComputeScroll()

Point SmallMapWindow::ComputeScroll | ( | int | tx,
|  | int | ty,
|  | int | x,
|  | int | y,
|  | int * | sub
| ) |  | const
| inlineprotected

Compute base parameters of the smallmap such that tile (tx, ty) starts at pixel (x, y).

Parameters

  | tx | Tile x coordinate.
  | ty | Tile y coordinate.
  | x | Non-negative horizontal position in the display where the tile starts.
  | y | Non-negative vertical position in the display where the tile starts.
  [out] | sub | Value of subscroll needed.

Returns
  scroll_x, scroll_y values.

Definition at line 1180 of file smallmap_gui.cpp.

References TILE_SIZE, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawHorizMapIndicator()

static void SmallMapWindow::DrawHorizMapIndicator | ( | int | x,
|  | int | x2,
|  | int | y
| ) |  |
| inlinestaticprotected

Draws horizontal part of map indicator.

Parameters

  x | X coord of left border of main viewport
  x2 | X coord of right border of main viewport
  y | Y coord of top/bottom border of main viewport

Definition at line 687 of file smallmap_gui.cpp.

References GfxFillRect(), and PC_VERY_LIGHT_YELLOW.

Referenced by DrawMapIndicators().

## ◆ DrawIndustryNames()

void SmallMapWindow::DrawIndustryNames | ( | const DrawPixelInfo * | dpi,
|  | const int | vertical_padding
| ) |  | const
| inlineprotected

Adds industry names to the smallmap.

Parameters

  dpi | the part of the smallmap to be drawn into

Definition at line 1011 of file smallmap_gui.cpp.

References _industry_to_list_pos, _industry_to_name_string_width, _legend_from_industries, _smallmap_industry_highlight, _smallmap_industry_highlight_state, DrawString(), FS_SMALL, GetCharacterHeight(), GetStringBoundingBox(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_industry_pool >::Iterate(), LegendAndColour::legend, SA_LEFT, LegendAndColour::show_on_map, TileX(), TileY(), LegendAndColour::type, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawMapIndicators()

void SmallMapWindow::DrawMapIndicators | ( |  | ) | const
| inlineprotected

Adds map indicators to the smallmap.

Definition at line 876 of file smallmap_gui.cpp.

References DrawHorizMapIndicator(), DrawVertMapIndicator(), GetMainWindow(), InverseRemapCoords2(), TILE_SIZE, Window::viewport, Viewport::virtual_height, Viewport::virtual_left, Viewport::virtual_top, Viewport::virtual_width, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawSmallMap()

void SmallMapWindow::DrawSmallMap | ( | DrawPixelInfo * | dpi | ) | const
| inlineprotected

Draws the small map.

Basically, the small map is draw column of pixels by column of pixels. The pixels are drawn directly into the screen buffer. The final map is drawn in multiple passes. The passes are:

1. The colours of tiles in the different modes.
2. Town names (optional)

Parameters

  dpi | pointer to pixel to write onto

Definition at line 1057 of file smallmap_gui.cpp.

References BlitterFactory::GetCurrentBlitter(), GfxFillRect(), Blitter::MoveTo(), PC_BLACK, ScaleGUITrad(), TILE_SIZE, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawSmallMapColumn()

void SmallMapWindow::DrawSmallMapColumn | ( | void * | dst,
|  | uint | xc,
|  | uint | yc,
|  | int | pitch,
|  | int | reps,
|  | int | start_pos,
|  | int | end_pos,
|  | Blitter * | blitter
| ) |  | const
| inlineprotected

Draws one column of tiles of the small map in a certain mode onto the screen buffer, skipping the shifted rows in between.

Parameters

  dst | Pointer to a part of the screen buffer to write to.
  xc | The X coordinate of the first tile in the column.
  yc | The Y coordinate of the first tile in the column
  pitch | Number of pixels to advance in the screen buffer each time a pixel is written.
  reps | Number of lines to draw
  start_pos | Position of first pixel to draw.
  end_pos | Position of last pixel to draw (exclusive).
  blitter | current blitter

Note
  If pixel position is below `0`, skip drawing.

Definition at line 910 of file smallmap_gui.cpp.

References _settings_game, OrthogonalTileArea::ClampToMap(), GameSettings::construction, ConstructionSettings::freeform_edges, Map::MaxX(), Map::MaxY(), Blitter::MoveTo(), Blitter::SetPixel(), and TileXY().

## ◆ DrawTowns()

void SmallMapWindow::DrawTowns | ( | const DrawPixelInfo * | dpi,
|  | const int | vertical_padding
| ) |  | const
| inlineprotected

Adds town names to the smallmap.

Parameters

  dpi | the part of the smallmap to be drawn into

Definition at line 988 of file smallmap_gui.cpp.

References DrawString(), FS_SMALL, GetCharacterHeight(), GetString(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_town_pool >::Iterate(), TileX(), TileY(), Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawVehicles()

void SmallMapWindow::DrawVehicles | ( | const DrawPixelInfo * | dpi,
|  | Blitter * | blitter
| ) |  | const
| inlineprotected

Adds vehicles to the smallmap.

Parameters

  dpi | the part of the smallmap to be drawn into
  blitter | current blitter

Definition at line 950 of file smallmap_gui.cpp.

References _vehicle_type_colours, IsInsideMM(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_vehicle_pool >::Iterate(), PC_WHITE, Blitter::SetPixel(), TILE_SIZE, VEH_EFFECT, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ DrawVertMapIndicator()

static void SmallMapWindow::DrawVertMapIndicator | ( | int | x,
|  | int | y,
|  | int | y2
| ) |  |
| inlinestaticprotected

Draws vertical part of map indicator.

Parameters

  x | X coord of left/right border of main viewport
  y | Y coord of top border of main viewport
  y2 | Y coord of bottom border of main viewport

Definition at line 675 of file smallmap_gui.cpp.

References GfxFillRect(), and PC_VERY_LIGHT_YELLOW.

Referenced by DrawMapIndicators().

## ◆ DrawWidget()

void SmallMapWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1598 of file smallmap_gui.cpp.

References _current_text_dir, _smallmap_industry_highlight, _smallmap_industry_highlight_state, WidgetDimensions::bevel, DrawString(), LegendAndColour::end, FillDrawPixelInfo(), FS_SMALL, GetCharacterHeight(), Industry::GetIndustryTypeCount(), GetString(), GetStringWithArgs(), GfxFillRect(), Rect::Indent(), NWidgetBase::padding, PC_BLACK, PC_WHITE, WidgetDimensions::scaled, ScaleGUITrad(), Rect::Shrink(), TD_RTL, TILE_HEIGHT_STEP, Rect::Translate(), WID_SM_LEGEND, WID_SM_MAP, Rect::Width(), Rect::WithHeight(), and Rect::WithWidth().

## ◆ ForceRefresh()

void SmallMapWindow::ForceRefresh | ( |  | ) |
| inlineprotected

Force a full refresh of the map.

Definition at line 1442 of file smallmap_gui.cpp.

References _smallmap_industry_highlight.

## ◆ GetLegendHeight()

uint SmallMapWindow::GetLegendHeight | ( | uint | num_columns | ) | const
| inlineprotected

Compute height given a number of columns.

Parameters

  num_columns | Number of columns.

Returns
  Needed height for displaying the smallmap legends in pixels.

Definition at line 716 of file smallmap_gui.cpp.

References WidgetDimensions::framerect, FS_SMALL, GetCharacterHeight(), WidgetDimensions::scaled, and RectPadding::Vertical().

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

## ◆ GetMinLegendWidth()

uint SmallMapWindow::GetMinLegendWidth | ( |  | ) | const
| inlineprotected

Compute minimal required width of the legends.

Returns
  Minimally needed width for displaying the smallmap legends in pixels.

Definition at line 697 of file smallmap_gui.cpp.

References WidgetDimensions::framerect, and WidgetDimensions::scaled.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

## ◆ GetNumberColumnsLegend()

uint SmallMapWindow::GetNumberColumnsLegend | ( | uint | width | ) | const
| inlineprotected

Return number of columns that can be displayed in width pixels.

Returns
  Number of columns to display.

Definition at line 706 of file smallmap_gui.cpp.

## ◆ GetNumberRowsLegend()

uint SmallMapWindow::GetNumberRowsLegend | ( | uint | columns | ) | const
| inlineprotected

Get the number of rows in the legend from the number of columns.

Those are at least min_number_of_fixed_rows and possibly more if there are so many cargoes, industry types or companies that they won't fit in the available space.

Parameters

  columns | Number of columns in the legend.

Returns
  Number of rows needed for everything to fit in.

Definition at line 775 of file smallmap_gui.cpp.

References _smallmap_cargo_count, _smallmap_company_count, _smallmap_industry_count, and CeilDiv().

## ◆ GetOverlayCompanyMask()

CompanyMask SmallMapWindow::GetOverlayCompanyMask | ( |  | ) | const
| inlineprotected

Get a bitmask for company links to be displayed.

Usually this will be the _local_company. Spectators get to see all companies' links.

Returns
  Company mask.

Definition at line 727 of file smallmap_gui.cpp.

References _local_company, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_company_pool >::IsValidID(), and BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Set().

## ◆ GetPositionOnLegend()

int SmallMapWindow::GetPositionOnLegend | ( | Point | pt | ) |
| inlineprotected

Determines the mouse position on the legend.

Parameters

  pt | Mouse position.

Returns
  Legend item under the mouse.

Definition at line 1401 of file smallmap_gui.cpp.

References _current_text_dir, NWidgetBase::current_x, WidgetDimensions::framerect, FS_SMALL, GetCharacterHeight(), NWidgetBase::pos_x, NWidgetBase::pos_y, WidgetDimensions::scaled, TD_RTL, WID_SM_LEGEND, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ GetStationMiddle()

Point SmallMapWindow::GetStationMiddle | ( | const Station * | st | ) | const
| inline

Get the center of the given station as point on the screen in the smallmap window.

Parameters

  st | Station to find in the smallmap.

Returns
  Point with coordinates of the station.

Definition at line 1496 of file smallmap_gui.cpp.

References CentreBounds(), BaseStation::rect, and Coord2D< T >::x.

## ◆ GetTileColours()

uint32_t SmallMapWindow::GetTileColours | ( | const TileArea & | ta | ) | const
| inlineprotected

Decide which colours to show to the user for a group of tiles.

Parameters

  ta | Tile area to investigate.

Returns
  Colours to display.

Definition at line 1320 of file smallmap_gui.cpp.

References _industry_to_list_pos, _legend_from_industries, _smallmap_industry_highlight, _smallmap_industry_highlight_state, _tiletype_importance, Industry::GetByTile(), GetIndustrySpec(), GetSmallMapContoursPixels(), GetSmallMapIndustriesPixels(), GetSmallMapLinkStatsPixels(), GetSmallMapOwnerPixels(), GetSmallMapRoutesPixels(), GetSmallMapVegetationPixels(), GetSmallMapVehiclesPixels(), GetTileType(), GetTunnelBridgeTransportType(), IfEnabled, INVALID_TILE, IsTileOnWater(), IndustrySpec::map_colour, MP_CLEAR, MP_INDUSTRY, MP_RAILWAY, MP_ROAD, MP_TUNNELBRIDGE, MP_VOID, MP_WATER, PixelColour::p, PC_WHITE, TRANSPORT_RAIL, TRANSPORT_ROAD, and Industry::type.

## ◆ GetWidgetString()

std::string SmallMapWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 1515 of file smallmap_gui.cpp.

References GetString(), Window::GetWidgetString(), and WID_SM_CAPTION.

## ◆ OnClick()

void SmallMapWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1699 of file smallmap_gui.cpp.

References _legend_from_industries, _legend_linkstats, _smallmap_cargo_count, _smallmap_company_count, _smallmap_industry_count, _smallmap_show_heightmap, NWidgetBase::current_x, NWidgetBase::current_y, LegendAndColour::end, GetMainWindow(), LegendAndColour::legend, NUM_NO_COMPANY_ENTRIES, NWidgetBase::pos_x, NWidgetBase::pos_y, ScrollWindowTo(), NWidgetBase::SetDirty(), LegendAndColour::show_on_map, SndClickBeep(), TILE_SIZE, WID_SM_CENTERMAP, WID_SM_CONTOUR, WID_SM_DISABLE_ALL, WID_SM_ENABLE_ALL, WID_SM_INDUSTRIES, WID_SM_LEGEND, WID_SM_LINKSTATS, WID_SM_MAP, WID_SM_OWNERS, WID_SM_ROUTES, WID_SM_SHOW_HEIGHT, WID_SM_SHOW_IND_NAMES, WID_SM_TOGGLETOWNNAME, WID_SM_VEGETATION, WID_SM_VEHICLES, WID_SM_ZOOM_IN, and WID_SM_ZOOM_OUT.

## ◆ OnInit()

void SmallMapWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 1526 of file smallmap_gui.cpp.

References _industry_to_name_string_width, _linkstat_colours_in_legenda, BuildOwnerLegend(), LegendAndColour::end, WidgetDimensions::framerect, FS_SMALL, GetCharacterHeight(), GetString(), GetStringBoundingBox(), RectPadding::Horizontal(), WidgetDimensions::hsep_normal, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_company_pool >::IsValidID(), lengthof, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::MAX_SIZE, WidgetDimensions::scaled, and TILE_HEIGHT_STEP.

## ◆ OnInvalidateData()

void SmallMapWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data. data = 0: Displayed industries at the industry chain window have changed. data = 1: Companies have changed. data = 2: Cheat changing the maximum heightlevel has been used, rebuild our heightlevel-to-colour index
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1822 of file smallmap_gui.cpp.

References _displayed_industries, _legend_from_industries, _smallmap_industry_count, NWidgetBase::SetDirty(), LegendAndColour::show_on_map, and NWidgetBase::type.

## ◆ OnMouseOver()

void SmallMapWindow::OnMouseOver | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

The mouse is currently moving over the window or has just moved outside of the window.

In the latter case pt is (-1, -1).

Parameters

  pt | the point inside the window that the mouse hovers over.
  widget | the widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1883 of file smallmap_gui.cpp.

References _legend_from_industries, _smallmap_industry_count, _smallmap_industry_highlight, _smallmap_industry_highlight_state, NWidgetBase::SetDirty(), LegendAndColour::type, and WID_SM_LEGEND.

## ◆ OnMouseWheel()

void SmallMapWindow::OnMouseWheel | ( | int | wheel,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

The mouse wheel has been turned.

Parameters

  wheel | the amount of movement of the mouse wheel.
  widget | the widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1859 of file smallmap_gui.cpp.

References _settings_client, ClientSettings::gui, CursorVars::pos, NWidgetBase::pos_x, NWidgetBase::pos_y, GUISettings::scrollwheel_scrolling, SWS_OFF, WID_SM_MAP, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ OnPaint()

void SmallMapWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1582 of file smallmap_gui.cpp.

References BuildOwnerLegend(), LegendAndColour::end, and Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_company_pool >::IsValidID().

## ◆ OnRightClick()

bool SmallMapWindow::OnRightClick | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A click with the right mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.

Returns
  true if the click was actually handled, i.e. do not show a tooltip if tooltip-on-right-click is enabled.

Reimplemented from Window.

Definition at line 1851 of file smallmap_gui.cpp.

References _scrolling_viewport, and WID_SM_MAP.

## ◆ OnScroll()

void SmallMapWindow::OnScroll | ( | Point | delta | ) |
| inlineoverridevirtual

Handle the request for (viewport) scrolling.

Parameters

  delta | the amount the viewport must be scrolled.

Reimplemented from Window.

Definition at line 1871 of file smallmap_gui.cpp.

References _settings_client, CursorVars::fix_at, ClientSettings::gui, GUISettings::scroll_mode, NWidgetBase::SetDirty(), TILE_SIZE, VSM_MAP_RMB_FIXED, VSM_VIEWPORT_RMB_FIXED, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ PixelToTile()

Point SmallMapWindow::PixelToTile | ( | int | px,
|  | int | py,
|  | int * | sub,
|  | bool | add_sub = `true`
| ) |  | const
| inlineprotected

Determine the tile relative to the base tile of the smallmap, and the pixel position at that tile for a point in the smallmap.

Parameters

  | px | Horizontal coordinate of the pixel.
  | py | Vertical coordinate of the pixel.
  [out] | sub | Pixel position at the tile (0..3).
  | add_sub | Add current subscroll to the position.

Returns
  Tile being displayed at the given position relative to scroll_x and scroll_y.

Note
  The subscroll offset is already accounted for.

Definition at line 1148 of file smallmap_gui.cpp.

References Coord2D< T >::x, and Coord2D< T >::y.

## ◆ RebuildColourIndexIfNecessary()

void SmallMapWindow::RebuildColourIndexIfNecessary | ( |  | ) |
| inlineprotected

Rebuilds the colour indices used for fast access to the smallmap contour colours based on the heightlevel.

Definition at line 745 of file smallmap_gui.cpp.

References _heightmap_schemes, _settings_game, BuildLandLegend(), GameSettings::construction, ConstructionSettings::map_height_limit, and map_height_limit.

## ◆ RemapTile()

Point SmallMapWindow::RemapTile | ( | int | tile_x,
|  | int | tile_y
| ) |  | const
| inlineprotected

Remap tile to location on this smallmap.

Parameters

  tile_x | X coordinate of the tile.
  tile_y | Y coordinate of the tile.

Returns
  Position to draw on.

Definition at line 1124 of file smallmap_gui.cpp.

References TILE_SIZE.

## ◆ SelectLegendItem()

void SmallMapWindow::SelectLegendItem | ( | int | click_pos,
|  | LegendAndColour * | legend,
|  | int | end_legend_item,
|  | int | begin_legend_item = `0`
| ) |  |
| inlineprotected

Select and toggle a legend item.

When CTRL is pressed, disable all other items in the group defined by begin_legend_item and end_legend_item and keep the clicked one enabled even if it was already enabled before. If the other items in the group are all disabled already and CTRL is pressed enable them instead.

Parameters

  click_pos | the index of the item being selected
  legend | the legend from which we select
  end_legend_item | index one past the last item in the group to be inverted
  begin_legend_item | index of the first item in the group to be inverted

Definition at line 794 of file smallmap_gui.cpp.

References _ctrl_pressed, and LegendAndColour::show_on_map.

## ◆ SetNewScroll()

void SmallMapWindow::SetNewScroll | ( | int | sx,
|  | int | sy,
|  | int | sub
| ) |  |
| inlineprotected

Set new scroll_x, scroll_y, and subscroll values after limiting them such that the center of the smallmap always contains a part of the map.

Parameters

  sx | Proposed new scroll_x
  sy | Proposed new scroll_y
  sub | Proposed new subscroll

Definition at line 843 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, InverseRemapCoords(), Map::MaxX(), Map::MaxY(), TILE_SIZE, WID_SM_MAP, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ SetOverlayCargoMask()

void SmallMapWindow::SetOverlayCargoMask | ( |  | ) |
| inlineprotected

Set the link graph overlay cargo mask from the legend.

Definition at line 1255 of file smallmap_gui.cpp.

References _legend_linkstats, _smallmap_cargo_count, and SetBit().

## ◆ SetupWidgetData()

void SmallMapWindow::SetupWidgetData | ( |  | ) |
| inlineprotected

Function to set up widgets depending on the information being shown on the smallmap.

Definition at line 1267 of file smallmap_gui.cpp.

References SZSP_NONE, WID_SM_DISABLE_ALL, WID_SM_ENABLE_ALL, WID_SM_LEGEND, WID_SM_SELECT_BUTTONS, and WID_SM_SHOW_IND_NAMES_SEL.

## ◆ SetZoomLevel()

void SmallMapWindow::SetZoomLevel | ( | ZoomLevelChange | change,
|  | const Point * | zoom_pt
| ) |  |
| inlineprotected

Initialize or change the zoom level.

Parameters

  change | Way to change the zoom level.
  zoom_pt | Position to keep fixed while zooming.

Precondition
  `*zoom_pt` should contain a point in the smallmap display when zooming in or out.

Definition at line 1208 of file smallmap_gui.cpp.

References Clamp(), lengthof, TILE_SIZE, WID_SM_ZOOM_IN, WID_SM_ZOOM_OUT, Coord2D< T >::x, and Coord2D< T >::y.

## ◆ SmallMapCenterOnCurrentPos()

void SmallMapWindow::SmallMapCenterOnCurrentPos | ( |  | ) |
| inline

Center the small map on the current center of the viewport.

Definition at line 1478 of file smallmap_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, GetMainWindow(), InverseRemapCoords2(), NWidgetBase::SetDirty(), TILE_SIZE, Window::viewport, Viewport::virtual_height, Viewport::virtual_left, Viewport::virtual_top, Viewport::virtual_width, WID_SM_MAP, Coord2D< T >::x, and Coord2D< T >::y.

Referenced by ScrollMainWindowTo().

## ◆ SmallmapRemapCoords()

static Point SmallMapWindow::SmallmapRemapCoords | ( | int | x,
|  | int | y
| ) |  |
| inlinestaticprotected

Definition at line 661 of file smallmap_gui.cpp.

## ◆ SwitchMapType()

void SmallMapWindow::SwitchMapType | ( | SmallMapType | map_type | ) |
| inlineprotected

Select a new map type.

Parameters

  map_type | New map type.

Definition at line 823 of file smallmap_gui.cpp.

References WID_SM_CONTOUR.

## ◆ UpdateLinks()

void SmallMapWindow::UpdateLinks | ( |  | ) |
| inlineprotected

Update all the links on the map.

Definition at line 1418 of file smallmap_gui.cpp.

## Friends And Related Symbol Documentation

## ◆ NWidgetSmallmapDisplay

friend class NWidgetSmallmapDisplay
| friend

Definition at line 1451 of file smallmap_gui.cpp.

## Field Documentation

## ◆ blink_interval

const IntervalTimer<TimerWindow> SmallMapWindow::blink_interval
| protected

Initial value:
= {TIMER_BLINK_INTERVAL, [this](auto) {
Blink();
}}
SmallMapWindow::Blink
void Blink()
Blink the industries (if hover over an industry).
Definition smallmap_gui.cpp:1431
TIMER_BLINK_INTERVAL
static constexpr std::chrono::milliseconds TIMER_BLINK_INTERVAL
Interval used by blinking interface elements.
Definition timer_window.h:36

Blink the industries (if selected) on a regular interval.

Definition at line 733 of file smallmap_gui.cpp.

## ◆ column_width

uint SmallMapWindow::column_width = 0
| protected

Width of a column in the WID_SM_LEGEND widget.

Definition at line 645 of file smallmap_gui.cpp.

## ◆ INDUSTRY_MIN_NUMBER_OF_COLUMNS

const uint SmallMapWindow::INDUSTRY_MIN_NUMBER_OF_COLUMNS = 2
| staticprotected

Minimal number of columns in the WID_SM_LEGEND widget for the SMT_INDUSTRY legend.

Definition at line 641 of file smallmap_gui.cpp.

## ◆ legend_width

uint SmallMapWindow::legend_width = 0
| protected

Width of legend 'blob'.

Definition at line 646 of file smallmap_gui.cpp.

## ◆ map_height_limit

int SmallMapWindow::map_height_limit = -1
| staticprotected

Currently used/cached map height limit.

Definition at line 639 of file smallmap_gui.cpp.

Referenced by RebuildColourIndexIfNecessary().

## ◆ map_type

SmallMapType SmallMapWindow::map_type = SMT_CONTOUR
| staticprotected

Currently displayed legends.

Definition at line 636 of file smallmap_gui.cpp.

## ◆ min_number_of_columns

uint SmallMapWindow::min_number_of_columns = 0
| protected

Minimal number of columns in legends.

Definition at line 643 of file smallmap_gui.cpp.

Referenced by NWidgetSmallmapDisplay::SetupSmallestSize().

## ◆ min_number_of_fixed_rows

uint SmallMapWindow::min_number_of_fixed_rows = 0
| protected

Minimal number of rows in the legends for the fixed layouts only (all except SMT_INDUSTRY).

Definition at line 644 of file smallmap_gui.cpp.

## ◆ overlay

std::unique_ptr<LinkGraphOverlay> SmallMapWindow::overlay {}
| protected

Definition at line 653 of file smallmap_gui.cpp.

## ◆ refresh_interval

const IntervalTimer<TimerWindow> SmallMapWindow::refresh_interval
| protected

Initial value:
= {std::chrono::milliseconds(930), [this](auto) {
ForceRefresh();
}}
SmallMapWindow::ForceRefresh
void ForceRefresh()
Force a full refresh of the map.
Definition smallmap_gui.cpp:1442

Update the whole map on a regular interval.

Definition at line 738 of file smallmap_gui.cpp.

## ◆ scroll_x

int32_t SmallMapWindow::scroll_x = 0
| protected

Horizontal world coordinate of the base tile left of the top-left corner of the smallmap display.

Definition at line 648 of file smallmap_gui.cpp.

## ◆ scroll_y

int32_t SmallMapWindow::scroll_y = 0
| protected

Vertical world coordinate of the base tile left of the top-left corner of the smallmap display.

Definition at line 649 of file smallmap_gui.cpp.

## ◆ show_ind_names

bool SmallMapWindow::show_ind_names = false
| staticprotected

Display industry names in the smallmap.

Definition at line 638 of file smallmap_gui.cpp.

## ◆ show_towns

bool SmallMapWindow::show_towns = true
| staticprotected

Display town names in the smallmap.

Definition at line 637 of file smallmap_gui.cpp.

## ◆ subscroll

int32_t SmallMapWindow::subscroll = 0
| protected

Number of pixels (0..3) between the right end of the base tile and the pixel at the top-left corner of the smallmap display.

Definition at line 650 of file smallmap_gui.cpp.

## ◆ zoom

int SmallMapWindow::zoom = 0
| protected

Zoom level. Bigger number means more zoom-out (further away).

Definition at line 651 of file smallmap_gui.cpp.

The documentation for this class was generated from the following file:

- src/smallmap_gui.cpp